///////////////////////////////////////////////////////////////////////////////
//Standard-Map mit Möglichkeit zum zoomen und einzelne Trajektorien zu erzeugen
//Rechtsklick: Zoomen an diesem Punkt
//Linksklick: Trajektorie eintragen
//Gewählte Darstellung: Zylinder  SxR
//Schwerpunkt: Fixpunkte erster bis dritter Ordnung
//Version: angepasst auf K = 0.971635 (für geringere Rechenzeit)
//Für andere Werte von K müssen die Suchbereiche für die Fixpunkte angepasst werden!
////////////////////////////////////////////////////////////////////////////////

//Bildausschnitt zu Beginn: (Benötigt kein double, da einmalig)
double xU = 0; double xO = 2*Math.PI;
double yU = 0 ; double yO = 2*Math.PI;

double  xUNeu, xONeu, yUNeu, yONeu,xAlt, yAlt, xNeu, yNeu;
double  xH, yH; 
double abstand;//Abstand von Punkt und Bildpunkt bei Fixpunktsuche
double Min ;//Speicher für das Minimum der Abstände von Punkt und Bildpunkt
double x0,y0,x1,y1;//für die Bestimmung der Fixpunkte
double untereGrenze ,obereGrenze ;//eingeschränkter Suchbereich
double x3,x4; //um weitere Fixpunkte zu bestimmen
int ordnung;
PFont font;
int w = 600; int h = 600; 
int xK, yK; //Koordinaten der Punkte
int n, i, l, L, M; //Erläuterung im setup()
int f; //für die Farbe
double K;//Störungsparameter
boolean zeichnen, trajektZeichnen, schonTransparent;
boolean istErsterOrdnung, istZweiterOrdnung, istDritterOrdnung;
boolean ergebnisZeigen;
PImage bild;
///////////////////////////////////////////////////////////////////////////
void setup(){ 
   size(600, 600);
  background(0); 
  fill(255);
  smooth();
  textSize(16);
  K = 0.971635; //erster Parameter der Map: Rotationszahl ist goldener Schnitt
  //K = 0.7; //testen!
  abstand =0;
  text("K = "+K, 20, 20);
  n= 5000;  //n...Anzahl der Iterationen
  L =200; //L Zufallsstartpunkte
  l = 0; //zählt die Zufallspunkte
  M = 5000; //Anzahl der Punkte auf einer ausgewählten Trajektorie
  xUNeu = xU; xONeu = xO;
  yUNeu = yU; yONeu = yO;
  println("K = "+K,"xU = "+xUNeu,"xO = "+xONeu,"yU = "+yUNeu,"yO = "+yONeu); //Info
  zeichnen = true;
  trajektZeichnen = false;
  schonTransparent = false;
  istErsterOrdnung = false;
  istZweiterOrdnung = false;
  istDritterOrdnung = false;
  bild = createImage(w,h,RGB);
  strokeWeight(1); 
}
///////////////////////////////////////////////////////////////////////////////////// 
 void draw(){//Maps mit variierendem Parameter K zeichnen
   if(zeichnen){
     //zufällige Startpunkte aus dem angezeigten Ausschnitt  
      xH =random((float)xUNeu,(float)xONeu);    
      yH =random((float)yUNeu,(float)yONeu);    
      iteriere(xH,yH,n,K);      
   }     
   if(l<L){
      l++;  
   }     
   if(l>=L && !trajektZeichnen){     
       zeichnen = false;       
       tint(255,5);//aktiviert:Bild wird teiltransparent, um die Trajektoerie besser zu sehen
   }    
 }
//Aus gegebenem Startpunkt (xH,yH) die folgenden n Punkte berechnen
////////////////////////////////////////////////////////
void iteriere(double xH, double yH, int N ,double K){  
  colorMode(HSB,256,256,256); 
  i=0;
  this.K =K;
  xAlt = (double)xH; 
  yAlt = (double)yH;
  point(xK,yK); 
  n =   N;
  stroke(color(f%256,255,255));
 // strokeWeight(2);  
  while(i <=n){  
       yNeu = yAlt + K*Math.sin(xAlt); 
       xNeu = (xAlt + yNeu) % (2*Math.PI);  
       if(xNeu <0) xNeu = 2*Math.PI+xNeu;//damit  xNeu > 0
       yK = round( map((float)yNeu,(float)yU,(float)yO,h,0));                 
       xK = round (map((float)xNeu,(float)xU,(float)xO,0,w));      
      point(xK,yK); 
     
       xAlt = xNeu;
       yAlt = yNeu;
       i++; 
  }
   i=0;  f++;  
   text("K = "+K, 20, 20);
}
///////////////////////////////////////////////////////////////////
void AchsenZeichnen(){
  stroke(255,200); 
  line(0,h,w/2,0); // enthält hyperbolischen Fixpunkt 2.Ordnung
  line(w/2,h,w,0); // ebenso
  line(w/2,0,w/2,h); //waagrechte Höhe PI
}
/////////////////////////////////////////////////////////
void fixpunkteEintragen(double x, double y){
   if(istErsterOrdnung){ strokeWeight(18);stroke(255);}
   if(istZweiterOrdnung){strokeWeight(12);stroke(color(0,255,255));}
   if(istDritterOrdnung){strokeWeight(12);stroke(color(30,255,255));}
 
   yK = round(map((float)y,(float)yU,(float)yO,h,0));                 
   xK = round(map((float)x,(float)xU,(float)xO,0,w));      
   point(xK,yK);   
   strokeWeight(1);
}
////////////////////////////////////////////////////////////////
void fixpunktIterieren(double uG, double oG, int ord, int wahl){
   println("Start");   
   untereGrenze = uG;
   obereGrenze = oG;
   ordnung = ord;
   Min = 10;
   x0 =0;
   y0 =0;
   int i =0;
    while(untereGrenze < obereGrenze){
      switch(wahl){
       case 0:
        xAlt = untereGrenze;
        yAlt = 2*xAlt;
        break;
       case 1:
        xAlt = 0;
        yAlt = untereGrenze;
        break;
       case 2:
        xAlt = untereGrenze;
        yAlt = 2*xAlt;
        break;
       case 3: 
        xAlt = Math.PI;
        yAlt = untereGrenze;
        break;
       case 4: 
        xAlt = untereGrenze;
        yAlt = 2*xAlt-2*Math.PI;
        break;
       case 5: 
        xAlt = x3;
        yAlt = untereGrenze;
        break;
       case 6: 
        xAlt = x4;
        yAlt = untereGrenze;
        break;
      }
        xH = xAlt; //merken, um Abstand zu berechnen
        yH = yAlt;
      while(i < ordnung){      
       yNeu = yAlt + K*Math.sin(xAlt); 
       xNeu = (xAlt + yNeu) % (2*Math.PI);
       xAlt = xNeu;
       yAlt = yNeu;  
       i++; 
     }
     i=0;
     abstand = Math.sqrt((xAlt-xH)*(xAlt-xH)+(yAlt-yH)*(yAlt-yH));
     if(abstand < Min) {
         Min = abstand;
         if(Min< 1.E-6){
           //println(xAlt,yAlt, Min);
           x0 =xAlt; y0 = yAlt; 
         }
     }     
     untereGrenze = untereGrenze + 0.0000001;
    } 
    text("K = "+K, 20, 20);
}
///////////////////////////////////////////////////////
void mousePressed() { 
  //////////////////////////////////////////////////////////
  //Trajektorie zeichnen
  //////////////////////////////////////////////////////////
  if(mouseButton == LEFT){
      trajektZeichnen = true;
      if(!schonTransparent){
        image(bild,0,0);  
        schonTransparent = true;//println("war hier");
      }   
      xH = map(mouseX,0,w,(float)xU,(float)xO); 
      yH = map(mouseY,0,h, (float)yO,(float)yU);
      println(xH,yH);
      f = f +19;
      iteriere(xH,yH,M,K);
      M = M + 2000;
  }
/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 5-fach vergrößert
//////////////////////////////////////////////////////
  if(mouseButton == RIGHT){
      trajektZeichnen = false;
      background(0);
      xUNeu = map(mouseX,0,w,(float)xU,(float)xO)-(xO-xU)/10;
      xONeu = map(mouseX,0,w,(float)xU,(float)xO)+(xO-xU)/10;
      yUNeu = map(mouseY,0,h, (float)yO,(float)yU)-(yO-yU)/10;
      yONeu = map(mouseY,0,h, (float)yO,(float)yU)+(yO-yU)/10;
      ///////////////////////////////////////////////
      double xK = map(mouseX,0,w,(float)xU,(float)xO);
      double yK = map(mouseY,0,h, (float)yO,(float)yU);
      println("Koordinaten: "+xK, yK);
      
      /////////////////////////////////////////////
      xU =(double) xUNeu; xO =(double) xONeu; yU = (double)yUNeu; yO = (double)yONeu;
      println("xU = "+xUNeu,"xO = "+xONeu,"yU = "+yUNeu,"yO = "+yONeu);
      l=0;
      n = 2*n;
      zeichnen = true;   
  }  
}
//////////////////////////////////////////////////////////////////
void keyPressed() {
  if(key == '1'){//Alle sichtbaren Fixpunkte 1. Ordnung eintragen 
     
      for(int i =0; i<=10;i++){
       for(int j =0; j<=5;j++){
          istErsterOrdnung = true;
          fixpunkteEintragen(i*Math.PI,j*2*Math.PI); 
          istErsterOrdnung = false;
       }
      }         
   }
   
  if(key == '2'){//vier Fixpunkte 2. Ordnung eintragen 
   
   //bekannte Fixpunkte 2.Ordnung 
    istZweiterOrdnung = true;
    fixpunkteEintragen(0,Math.PI); println(0,Math.PI);
    fixpunkteEintragen(Math.PI,Math.PI); println(Math.PI,Math.PI);
    fixpunkteEintragen(2*Math.PI,Math.PI);  println(2*Math.PI,Math.PI +"  identisch mit erstem Fixpunkt");
  
    //zwei hyperbolische Fixpunkte 2.Ordnung
     fixpunktIterieren(1.33,1.4,2,0);
     istZweiterOrdnung = true; println(x0,y0);
     fixpunkteEintragen(x0,y0);
     x1=2*Math.PI-x0;
     y1=2*Math.PI-y0;
     fixpunkteEintragen(x1,y1);println(x1,y1);
     istZweiterOrdnung = false;
  }
  
   if(key == '3'){// sechs Fixpunkte 3. Ordnung eintragen (Nummerierung von links nach rechts)
   
    //erster hyperbolischer Fixpunkt 3.Ordnung   
    fixpunktIterieren(1.6,1.8,3,1);
    istDritterOrdnung = true;println(0,y0);
    fixpunkteEintragen(0,y0);
    fixpunkteEintragen(2*Math.PI,y0);println(2*Math.PI,y0+"  identisch mit oberem Fixpunkt ");
    
   //erster elliptischer Fixpunkt 3.Ordnung   
    fixpunktIterieren(0.7,0.9,3,2);
    istDritterOrdnung = true;println(x0,y0);
    fixpunkteEintragen(x0,y0);  
    x3 = 2*Math.PI-x0; //für dritten elliptischen Fixpunkt

   //zweiten ellipt Fixpunkt 3.Ordnung   
    fixpunktIterieren(2.2,2.4,3,3);
    istDritterOrdnung = true;println(Math.PI,y0);
    fixpunkteEintragen(Math.PI,y0);  
    
   //dritter hyperbolischer Fixpunkt 3.Ordnung
    fixpunktIterieren(4.4,4.6,3,4);
    istDritterOrdnung = true;println(x0,y0);
    x4 =2*Math.PI- x0;//für zweiten hyp Fixpunkt    
    fixpunkteEintragen(x0,y0); 
    
   //dritter elliptischer Fixpunkt 3. Ordnung 
    fixpunktIterieren(2.1,2.5,3,5); 
    istDritterOrdnung = true;println(x3,y0);
    fixpunkteEintragen(x3,y0);
    
   //zweiter hyperbolischer Fixpunkt 3.Ordnung
     fixpunktIterieren(1.5,2.1,3,6); 
     istDritterOrdnung = true;println(x4,y0);
     fixpunkteEintragen(x4,y0);  
    
   // Fixpunkte 3. Ordnung fertig!
   
     istDritterOrdnung = false;
  }
  
  if(key == 'a'){
    AchsenZeichnen(); 
  }
  
}
